﻿
Public Class IconComboBox : Inherits TsControls.MultiLineComboBox
    Dim il As ImageList

    Sub New()
        TextLeftMargin = 20
        DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed
        ItemHeight = 17
    End Sub

    Sub init(ByRef imageList As ImageList)
        il = imageList
        AddHandler DrawItem, AddressOf IconComboBox_DrawItem
        AddHandler SelectedIndexChanged, AddressOf IconComboBox_SelectedIndexChanged
    End Sub

    Private Sub IconComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        CType(sender, IconComboBox).Invalidate()
    End Sub

    Private Sub IconComboBox_DrawItem(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DrawItemEventArgs)
        e.DrawBackground()
        Dim br As Brush = New SolidBrush(e.ForeColor)
        If e.Index >= 0 Then
            e.Graphics.DrawString(CType(Items(e.Index), DataRowView)(DisplayMember).ToString(), e.Font, br, 20, e.Bounds.Y + 2)
            il.Draw(e.Graphics, 2, e.Bounds.Y + 2, 16, 11, e.Index)
        End If

    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        If Not (il Is Nothing) Then
            If SelectedIndex >= 0 Then
                il.Draw(e.Graphics, 3, 4, 16, 11, SelectedIndex)
            End If
        End If
    End Sub
End Class
