﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
namespace IconComboBoxDemo
{
    class IconComboBox : TsControls.MultiLineComboBox
    {
        private ImageList il;

        public IconComboBox()
        {
            TextLeftMargin = 20;
            DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
            ItemHeight = 17;
        }

        public void init(ImageList imageList)
        {
            il = imageList;
            DrawItem += IconComboBox_DrawItem;
            SelectedIndexChanged += IconComboBox_SelectedIndexChanged;
        }

        private void IconComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            ((IconComboBox)sender).Invalidate();
        }

        private void IconComboBox_DrawItem(object sender, DrawItemEventArgs e)
        {
            e.DrawBackground();
            Brush br = new SolidBrush(e.ForeColor);
            if (e.Index >= 0)
            {
                e.Graphics.DrawString(((DataRowView)Items[e.Index])[DisplayMember].ToString(), e.Font, br, 20, e.Bounds.Y + 2);
                il.Draw(e.Graphics, 2, e.Bounds.Y + 2, 16, 11, e.Index);
            }
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            if (il != null)
            {
                if (SelectedIndex >= 0)
                {
                    il.Draw(e.Graphics, 3, 4, 16, 11, SelectedIndex);
                }
            }
        }
    }
}
